Mantis Bugtracker

Viewing Issue Advanced Details Jump to Notes ] View Simple ] Issue History ] Print ]
ID Category Severity Reproducibility Date Submitted Last Update
0002228 [Cacti] Interface - HTML/CSS major always 2012-05-13 05:27 2013-03-31 06:37
Reporter paulgevers View Status public  
Assigned To browniebraun
Priority normal Resolution open Platform
Status assigned   OS
Projection none   OS Version
ETA none Fixed in Version Product Version 0.8.8
  Target Version Product Build
Summary 0002228: GPL incompatible files included in Cacti project in include/treeview
Description Cacti is released under the GNU General Public License version 2 or higher. Going through the code I saw that the files in include/treeview/ don't have a very clear license statement. On the website of treeview [1], I found two possible licenses [2],[3] that I believe apply to the code. These licenses are incompatible with the GPL.

I have asked [4] the debian-legal e-mail list (as I package cacti for Debian) for advise, and the reply [5] was to contact you, to notify you of the issue.

Quoting from the last mail [5]
"""
Possible solutions I can think of:

 (A) if cacti may work without the non-free files (possibly with
reduced functionality), those files should be dropped entirely

 (B) if cacti cannot work without those files, appropriate DFSG-free
and GPL-compatible replacements should be found (or clean-room
developed)

 (C) Gubusoft should be contacted and persuaded to re-license those
files under GPLv2-compatible terms
"""

I believe (A) does not work, but I might be mistaken (I have not checked, yet). Of course the DFSG-freeness in (B) is relevant for Debian only (DFSG = Debian Free Software Guidelines).

How to proceed? If I can be of any help, let me know.

[1] http://www.treeview.net/ [^]
[2] http://www.treeview.net/tv/license_dist.asp [^]
[3] http://www.treeview.net/tv/license_dev.asp [^]
[4] http://lists.debian.org/debian-legal/2012/05/msg00019.html [^]
[5] http://lists.debian.org/debian-legal/2012/05/msg00020.html [^]
Steps To Reproduce
Additional Information
Tags patch
Attached Files ? file icon first_work_jstree.patch [^] (10,776 bytes) 2012-11-21 17:14 [Show Content]
? file icon Third-try-on-jstree-inclusion.patch [^] (24,920 bytes) 2012-11-24 16:22 [Show Content]
png file icon cacti_multiple_level.png [^] (19,248 bytes) 2013-01-19 12:44


png file icon broken-treeview.png [^] (12,518 bytes) 2013-01-19 13:24


html file icon cacti-tree.html [^] (301 bytes) 2013-01-19 13:27
? file icon replace_treeview_by_jquery.jstree.patch [^] (27,464 bytes) 2013-03-31 06:34 [Show Content]

- Relationships

-  Notes
(0006271)
paulgevers (reporter)
2012-06-16 06:01

Just asking if there is any progress on this issue. I have reread the license and I consider it such a problem for Debian that I am going to check if Cacti works "well enough" with out the files to be distributed, else Debian might have to drop Cacti all together, as I am not able to create the same functionality myself.

If you want I can contact Gubusoft to try and get a better license on the files (option C).
(0006277)
paulgevers (reporter)
2012-07-02 15:03

I tried to contact Gubusoft several days ago to get a re-license of the files, but got no response yet.

In the mean time, I am investigating the possibility to replace the javascript in those files by a real open source solution. Seems possible, e.g. http://www.dhtmlx.com/docs/products/dhtmlxTree/ [^]

Will keep you informed.
(0006278)
browniebraun (developer)
2012-07-03 01:25

The tree will be definitely replaced by jstree (http://www.jstree.com/) [^] in 0.8.9. I will start with that replacement at the end of this week. In the meanwhile I had to replace Zoom. Maybe you have already noticed that Zoom is incompatible to the GPL too.
Regards
-Andi
(0006280)
paulgevers (reporter)
2012-07-07 03:25

Thanks for working on this. If you need help, I will try to help.

Isn't Zoom (if you are talking about include/zoom.js) licensed under GPL2+? Or are you talking about some other part of cacti?
(0006281)
browniebraun (developer)
2012-07-08 04:23

Oops, you're right. It is under GPL2+ - I forgot that. I believe the main reason for having a replacement was that we wanted to have it under our copyright. However, 0.8.9 will include a much more powerful successor. :)

Regards
-Andi
(0006290)
paulgevers (reporter)
2012-08-21 16:16

I definitely don't want to annoy you, but is there any progress on this? Any way I can help?
(0006357)
paulgevers (reporter)
2012-11-21 17:16

Just added my first work on getting cacti to work with jstree. Not prefect and somebody with more cacti and php knowledge than I should check, but maybe this helps. The paths are definitely wrong, but at least point to where they need changing.

Please comment.

The patch is against current 0.8.8a code base.
(0006364)
paulgevers (reporter)
2012-11-24 11:19

Forget the file: first_work_jstree.patch

There are several mistakes in it. I am working on an improvement, and I try to get the graph_export.php file all-right as well.
(0006366)
paulgevers (reporter)
2012-11-24 16:27

I just uploaded my next try. As far as I can tell, with this patch everything works as it should. I think I tested everything, but please check.

The patch is against 0.8.8a.

Not in the patch, but on from cacti svn copied on my local system:
cacti/include/js/jquery/jquery(|.cookie|.jstree).js
cacti/include/js/jquery/themes/default/style.css
cacti/include/js/jquery/themes/default/d.(gif|png)
cacti/include/js/jquery/themes/default/throbber.gif
Either from the cacti main branch (themes) or 0.8.9 branch (jquery stuff).

If you have questions, please ask.
(0006387)
paulgevers (reporter)
2012-12-14 14:41

Please be aware that I applied the patch to the Debian package, in case questions about this pop up.
(0006433)
ktdreyer (reporter)
2013-01-11 14:10

paulgevers: is this patch working for you with multi-level trees? Fedora applied it in https://bugzilla.redhat.com/888207, [^] and their patch flattens all the levels into one sub-level. I'm trying to figure out if the bug is on Fedora's side or if this patch needs to be adjusted.
(0006434)
paulgevers (reporter)
2013-01-11 15:50

@ktdreyer could you attach a screenshot? I think my patched worked for multi-level trees, but maybe you can show what you mean, so I can verify on my system.
(0006435)
Linegod (administrator)
2013-01-11 18:56

Reminder sent to: gandalf, rony, TheWitness

FYI
(0006437)
paulgevers (reporter)
2013-01-19 12:46

@ktdreyer: please have a look at the screen shot I just attached to this bug. This is how it looks on my system. Did you expect anything else?
(0006438)
ktdreyer (reporter)
2013-01-19 13:24

Thank you for following up, even when I didn't get back with you :) Yes, that functionality is broken on two separate systems. I'm attaching screenshots to demonstrate.

Under "Console" -> "Graph Trees" -> "(Edit)", you can see that the second "emachine" Host entry is supposed to be a child of the "testing" Header. However, in the graph, the tree is flat, so that the second "emachine" Host entry appears to be a sibling of the "testing" header.

Here is how the HTML looks (adjusted to remove hrefs and whitespace):

<li id="tree_1">ktdreyer.com
  

        <li id="tree_1_leaf_7">Host: peredur
        <li id="tree_1_leaf_8">Host: emachine
        <li id="tree_1_leaf_9">testing
        <li id="tree_1_leaf_11">Host: emachine</a>
      



This demo is small, but the same problem occurs on my production Cacti system at work with about 70 tree entries.

I tested in both Firefox and Chromium. The web servers are CentOS 6 & RHEL 6, with PHP 5.3.3.

I've verified that my Third-try-on-jstree-inclusion.patch is identical to what's attached to this bug report (md5sum bb5e8ba3a6b3879317ddf56a3ab6cbbf). I wonder where the problem could be.
(0006439)
ktdreyer (reporter)
2013-01-19 13:27

I guess Mantis stripped some of the HTML formatting there. I'll attach it as a separate file.
(0006440)
paulgevers (reporter)
2013-01-19 14:47

Your code looks good (as far as you copy/paste it). Seems like there is a jquery/jstree issue?
(0006462)
paulgevers (reporter)
2013-03-10 12:28

Somebody in Debian reported a bug [1] which I think describes the issue very well AND he provides a patch. I still have to investigate the patch, but it works for him.

[1] http://bugs.debian.org/702690 [^]
(0006469)
paulgevers (reporter)
2013-03-31 06:37

I have updated my patch to include the bug fix in the debian report, including missing functionality in that report regarding lib/graph_export.php. See replace_treeview_by_jquery.jstree.patch

I have tested extensively, but a review would still be nice. Again, I am including this in the Debian packaging, and expect Fedora to do the same.

- Issue History
Date Modified Username Field Change
2012-05-13 05:27 paulgevers New Issue
2012-05-15 06:10 browniebraun Status new => assigned
2012-05-15 06:10 browniebraun Assigned To => browniebraun
2012-06-16 06:01 paulgevers Note Added: 0006271
2012-07-02 15:03 paulgevers Note Added: 0006277
2012-07-03 01:25 browniebraun Note Added: 0006278
2012-07-05 11:57 Linegod Issue Monitored: Linegod
2012-07-07 03:25 paulgevers Note Added: 0006280
2012-07-08 04:23 browniebraun Note Added: 0006281
2012-08-21 16:16 paulgevers Note Added: 0006290
2012-11-21 17:14 paulgevers File Added: first_work_jstree.patch
2012-11-21 17:16 paulgevers Note Added: 0006357
2012-11-24 11:19 paulgevers Note Added: 0006364
2012-11-24 16:22 paulgevers File Added: Third-try-on-jstree-inclusion.patch
2012-11-24 16:27 paulgevers Note Added: 0006366
2012-11-24 16:29 paulgevers Tag Attached: patch
2012-12-14 14:41 paulgevers Note Added: 0006387
2013-01-11 14:10 ktdreyer Note Added: 0006433
2013-01-11 15:50 paulgevers Note Added: 0006434
2013-01-11 18:56 Linegod Issue Monitored: gandalf
2013-01-11 18:56 Linegod Issue Monitored: rony
2013-01-11 18:56 Linegod Issue Monitored: TheWitness
2013-01-11 18:56 Linegod Note Added: 0006435
2013-01-19 12:44 paulgevers File Added: cacti_multiple_level.png
2013-01-19 12:46 paulgevers Note Added: 0006437
2013-01-19 13:24 ktdreyer Note Added: 0006438
2013-01-19 13:24 ktdreyer File Added: broken-treeview.png
2013-01-19 13:27 ktdreyer Note Added: 0006439
2013-01-19 13:27 ktdreyer File Added: cacti-tree.html
2013-01-19 14:47 paulgevers Note Added: 0006440
2013-03-10 12:28 paulgevers Note Added: 0006462
2013-03-31 06:34 paulgevers File Added: replace_treeview_by_jquery.jstree.patch
2013-03-31 06:37 paulgevers Note Added: 0006469


Mantis 1.1.6[^]
Copyright © 2000 - 2008 Mantis Group
Powered by Mantis Bugtracker